#ifndef __SHELLINABOXD_H__
#define __SHELLINABOXD_H__

#include <stdio.h>


#undef  QUERYHOST
#define USELOGIN
#undef  USEOLDPTYS
#undef  LOGPROTOCOLERRORS
#undef  DEBUGCONNECTIONS
#undef  DEBUGSESSIONS
#undef  DEBUGREQUESTS
#undef  DEBUGREPLIES
#undef  DEBUGFIFO
#undef  DEBUGLATENCY  1500


#define DATADIR       "shellinabox.data"
#define DEFAULTDOC    "shellinabox.html"
#define UNIXSOCKET    "/shellinabox.socket"
#define DAEMONPATH    "/shellinaboxd"
#define POLLTIMEOUT   (2*60-15)
#define CONNTIMEOUT   (2*60)
#define BLOCKSIZE     4096
#define WLCONTENTTYPE "application/x-shellinabox"
#define CONNECT       "connect"
#define DISCONNECT    "disconnect"
#define POLL          "poll"
#define DATA          "data"
#define PTYNAMELEN    40

#if defined(linux) && (defined(USELOGIN) || !defined(QUERYHOST))
#define TERMINAL      "linux"
#else
#define TERMINAL      "vt102"
#endif

#ifdef  QUERYHOST
#undef  USELOGIN
#endif

#ifdef  USELOGIN
#define LOGINPATH     "/bin/login"
#else
#define RLOGINPATH    "/usr/bin/rlogin"
#endif

#ifndef UNIX_PATH_MAX
#define UNIX_PATH_MAX 108
#endif


typedef struct ServerData ServerData;
typedef int   (*Fnc)(void);


#include "cgicomm.h"
#include "connectionmgr.h"
#include "fifo.h"
#include "server.h"
#include "session.h"


typedef void (*PollInFnc)      (int,Connection *,void *);
typedef void (*PollOutFnc)     (int,Connection *,void *);
typedef void (*PollHupFnc)     (int,Connection *,void *);
typedef void (*DestroyFnc)     (int,Connection *,void *);
typedef void (*DoTimeOutFnc)   (int,Connection *,void *);
typedef void (*ReapProcessFnc) (int,Connection *,void *,int);
typedef void (*ServeRequestFnc)(int,Connection *,void *,FIFO *,int,FIFO *);


enum { PollInIdx       = 0,PollOutIdx   = 1,PollHupIdx     = 2,
       DestroyIdx      = 3,DoTimeOutIdx = 4,ReapProcessIdx = 5,
       ServeRequestIdx = 6,
       VTABSIZE };


#define FNC(s,f) ((f##Fnc)((s)->vTable[f##Idx]?(s)->vTable[f##Idx]:noFnc))


struct ServerData {
    Fnc *vTable;
    union {
        CGIComm cg;
        Server  sv;
        Session ss;
    } u;
};


extern int        uid,euid;
extern const char *daemonPath;


void fAbortCGI(FIFO *fifo,int errCode,char *msg,...);
int  noFnc(void);

#endif

/*
 * Local variables:
 * mode: c
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
